//+------------------------------------------------------------------+
//|                                              First_Indicator.mq4 |
//|                                                            JustY |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "JustY"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Silver
//---- Parameter
extern int time1 = 3;
extern int time2 = 5;
extern int time3 = 7;

//---- buffers
double MomBurst[];
double Momdt[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,MomBurst);
   SetIndexBuffer(1,Momdt);
   string short_name = "MomentumBurst";
   IndicatorShortName(short_name);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   //----Check for Errors
   if (counted_bars<0) return(-1);
   //----last countet bar will recountet
   if (counted_bars>0) counted_bars--;
   
   int pos=Bars-counted_bars;
   double dMedian1, dMedian2, dMedian3, dResult;
   Comment("Hi! Im here on the main chart window!");
   //----main calculation loop
   
      while(pos>=0)   //---- Berechnung des Momentum (Geschwindigkeit)
      {
         dMedian1 = (High[pos+time1] + Low[pos+time1] + Open[pos+time1] + Close[pos+time1]) / 4;
         if (dMedian1 == 0) dMedian1 = 1;                     // Division durch Null verhindern
         dResult  = Close[pos]*100/dMedian1;                  // temporres Momentum
         dMedian2 = (High[pos+time2] + Low[pos+time2] + Open[pos+time2] + Close[pos+time2]) / 4;
         if (dMedian2 == 0) dMedian2 = 1;                     // Division durch Null verhindern
         dResult  = dResult + Close[pos]*100/dMedian2;        // temporres Momentum
         dMedian3 = (High[pos+time3] + Low[pos+time3] + Open[pos+time3] + Close[pos+time3]) / 4;
         if (dMedian3 == 0) dMedian3 = 1;                     // Division durch Null verhindern
         dResult  = dResult + Close[pos]*100/dMedian3;        // temporres Momentum
         MomBurst[pos] = dResult;                             // Summe der drei Momentum
         pos--;                                               // Inkrementiere Bar
      }
      
   pos=Bars-counted_bars;   //---- Berechnung der Momentumnderung (Beschleunigung)
      while(pos>=0)
      {
         dMedian1  = MomBurst[pos+time1];
         if (dMedian1 == 0) dMedian1 = 1;
         dResult   = MomBurst[pos]*100/dMedian1;
         dMedian2  = MomBurst[pos+time2];
         if (dMedian2 == 0) dMedian2 = 1;
         dResult   = dResult + MomBurst[pos]*100/dMedian2;
         dMedian3  = MomBurst[pos+time1];
         if (dMedian3 == 0) dMedian3 = 1;
         dResult   = dResult + MomBurst[pos]*100/dMedian3;
         Momdt[pos] = dResult; 
         pos--;
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+